#include <windows.h>
#include <shlwapi.h>

#pragma comment(lib, "shlwapi.lib")

int xdigit(char x)
{
	if(x < 'a') return x & 0xF;
	else return (x & 0xF) + 9;
}

int ParsePatchString(const char * str, char * out, int max)
{
	int len = 0;
	for(;;) {
		while(*str == ' ') ++str;
		if(!*str) break;

		if(::isxdigit((BYTE)str[0]) &&
		   ::isxdigit((BYTE)str[1])) {
			if(!max) return 0;
			*out++ = (xdigit(str[0]) << 4) | xdigit(str[1]);
			len++;
			max--;
		} else return 0;
		str += 2;
	}
	return len;
}

BOOL Hook(HMODULE hModule)
{
	char profilePath[1024 + MAX_PATH];
	::GetModuleFileName(hModule, profilePath, 1024);
	::PathRemoveFileSpec(profilePath);
	::PathAppend(profilePath, "swrmem.ini");

	char sections[1024];
	::GetPrivateProfileString(NULL, NULL, "", sections, _countof(sections), profilePath);
	for(char *sec = sections; *sec; sec += strlen(sec) + 1) {
		if(GetPrivateProfileInt(sec, "Enabled", 0, profilePath)) {
			char keys[1024];
			::GetPrivateProfileString(sec, NULL, "", keys, _countof(keys), profilePath);
			for(char *key = keys; *key; key += strlen(key) + 1) {
				char *end;
				DWORD target = ::strtoul(key, &end, 16);
				if(!*end) {
					char value[1024];
					::GetPrivateProfileString(sec, key, "", value, _countof(value), profilePath);
					char buff[256];
					int length = ParsePatchString(value, buff, _countof(buff));
					if(length) {
						DWORD old;
						if(::VirtualProtect((PVOID)target, length, PAGE_EXECUTE_WRITECOPY, &old)) {
							memcpy((PVOID)target, buff, length);
							::VirtualProtect((PVOID)target, length, old, &old);
						}
					}
				}
			}
		}
	}
	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook(hModule) : TRUE;
}
